var wav_worker = new Worker('./js/wav_convert.js');

var audioCtx;
var firstFlag = true;


////////////////////////////////////////////////////////////////////////////////
// Generic function
////////////////////////////////////////////////////////////////////////////////

// 現在時刻を取得する yyyymmddhhmmss形式
function GetDateTime_Now() {

  // 月日時分秒を2桁にする
  function DoubleDigit(Value) {
    var result = Value + "";

    if (result.length == 1) {
        return "0" + result;
    } else {
        return result;
    }
  }

  var NowTime = new Date();

  return NowTime.getFullYear() +
          DoubleDigit(NowTime.getMonth() + 1) + DoubleDigit(NowTime.getDate()) +
          DoubleDigit(NowTime.getHours()) + DoubleDigit(NowTime.getMinutes()) +
          DoubleDigit(NowTime.getSeconds());
}

// ファイルのダウンロード
function DownLoad(FileName,Stream,type) {
  if (window.navigator.msSaveBlob) {
    window.navigator.msSaveBlob(new Blob([Stream], { type: type }), FileName);
  } else {
    var a = document.createElement("a");
    a.href = URL.createObjectURL(new Blob([Stream], { type: type }));
    //a.target   = '_blank';
    a.download = FileName;
    document.body.appendChild(a); //  FF specification
    a.click();
    document.body.removeChild(a); //  FF specification
  }
}

////////////////////////////////////////////////////////////////////////////////
// イベント
////////////////////////////////////////////////////////////////////////////////

wav_worker.onmessage = function (e) {
  
  document.getElementById("progress_convert").style.display = "none";

  // 成功    
  if(e.data.state == "ok"){
    DownLoad(GetDateTime_Now()+ ".wav", e.data.stream,"audio/wav");  
  // エラー    
  }else if(e.data.state == "no"){
    alert("変換に失敗しました。");
  }
 console.timeEnd("run");    
}

function onDragOver(event){ 
  event.preventDefault(); 
} 
  
function onDrop(event){
  onAddFile(event);
  event.preventDefault(); 
}  

function onAddFile(event) {
  var files;
  var reader = new FileReader();
  
  if(event.target.files){
    files = event.target.files;
  }else{ 
    files = event.dataTransfer.files;   
  }    

  reader.onload = function (event) {

    if(firstFlag){
      audioCtx =  new AudioContext(); 
      firstFlag = false;     
    }    
    
    var bits = parseInt(document.getElementById("lst_bits").value,10);
       
    audioCtx.decodeAudioData(reader.result).then(function(source) {      
      
      console.time("run");  
      document.getElementById("progress_convert").style.display = "block";        
      
      var L = new Float32Array (source.getChannelData(0));
      var R = [];
      if(source.numberOfChannels == 2){
        var R = new Float32Array (source.getChannelData(1));
        wav_worker.postMessage({'state'   : 'run','bits': bits, 
                                'channel' : source.numberOfChannels,
                                'sampleRate' : source.sampleRate,                              
                                'L' : L,
                                'R' : R,
                                 } 
                                ,[L.buffer,R.buffer]);              
      }else{
        wav_worker.postMessage({'state'   : 'run','bits': bits, 
                                'channel' : source.numberOfChannels,
                                'sampleRate' : source.sampleRate,                              
                                'L' : L,
                                'R' : "",
                                 }); 
      }
      

        
    }).catch(function(e){
        alert("対応していない形式です。\n"+e);
    });     
  };
  
  if (files[0]){    
    reader.readAsArrayBuffer(files[0]); 
    document.getElementById("inputfile").value = "";
    document.getElementById("progress_convert").style.display = "none";   
  }
}   