/***********************************************/
/*                                             */
/*   WAVE.wasm.js                              */
/*                                      v1.00  */
/*                                             */
/*   Copyright 2019 Takeshi Okamoto (Japan)    */
/*                                             */
/*   Released under the MIT license            */
/*   https://github.com/TakeshiOkamoto         */
/*                                             */
/*                            Date: 2019-03-13 */
/***********************************************/
function WAV_Byte2Word(t){return t[1]<<8|t[0]}function WAV_Byte2DWord(t){return t[3]<<24|t[2]<<16|t[1]<<8|t[0]}function WAV_SetInt8(t){return 128==t?0:129>=t?t-128:-(128-t)}function WAV_SetUint8(t){return 0==t?128:1>=t?t+128:128+t}function WAV_SetInt16(t){return t>=32768?-(65536-t):t}function WAV_SetUint16(t){return t>=0&&32767>=t?t:65536+t}function WAV_SetInt24(t){return t>=8388608?-(16777216-t):t}function WAV_SetUint24(t){return t>=0&&8388607>=t?t:16777216+t}function WAV_SetInt32(t){return t>=2147483648?-(4294967296-t):t}function WAV_SetUint32(t){return t>=0&&2147483647>=t?t:4294967296+t}function TReadStream(t){this.Pos=0,this.Stream=t,this.FileSize=t.length}function TFileStream(t){void 0==t?this.MemorySize=5e7:this.MemorySize=parseInt(t,10),this.Size=0,this.Stream=new Uint8Array(this.MemorySize)}function TWaveAnalyst(t){var e="It is not a WAVE file.",a=new TReadStream(t),r=a.ReadString(4);if("RIFF"!=r)throw e;if(a.Read(4),r=a.ReadString(4),"WAVE"!=r)throw e;for(var n,s={};;){if(r=a.ReadString(4),"fmt "==r){n=WAV_Byte2DWord(a.Read(4)),s.wFormatTag=WAV_Byte2Word(a.Read(2)),s.nChannels=WAV_Byte2Word(a.Read(2)),s.nSamplesPerSec=WAV_Byte2DWord(a.Read(4)),s.nAvgBytesPerSec=WAV_Byte2DWord(a.Read(4)),s.nBlockAlign=WAV_Byte2Word(a.Read(2)),s.wBitsPerSample=WAV_Byte2Word(a.Read(2)),a.Pos=a.Pos+n-16;break}if(n=WAV_Byte2DWord(a.Read(4)),a.Pos+=n,a.Pos>=a.FileSize)throw e}for(var i;;){if(r=a.ReadString(4),"data"==r){n=WAV_Byte2DWord(a.Read(4)),i=a.Stream.subarray(a.Pos,a.Pos+n);break}var n=WAV_Byte2DWord(a.Read(4));if(a.Pos+=n,a.Pos>=a.FileSize)throw e}this.WaveFomat=s,this.raw=i,this.time=1e3*n/s.nAvgBytesPerSec,this.bps=s.nSamplesPerSec*s.wBitsPerSample*s.nChannels}function TWaveFormat(t,e){this.instance=t,this.stepSize=4096;try{this.Analyst=new TWaveAnalyst(e)}catch(a){throw a}}TReadStream.prototype={Read:function(t){var e=this.Stream.subarray(this.Pos,this.Pos+t);return this.Pos=this.Pos+t,e},ReadString:function(t){var e=String.fromCharCode.apply(null,this.Stream.subarray(this.Pos,this.Pos+t));return this.Pos=this.Pos+t,e}},TFileStream.prototype={_AsciiToUint8Array:function(t){for(var e=t.length,a=new Uint8Array(e),r=0;e>r;r++)a[r]=t[r].charCodeAt(0);return a},WriteByte:function(t){var e=new Uint8Array(1);e[0]=t,this.WriteStream(e)},WriteWord:function(t){var e=new Uint8Array(2);e[1]=(65280&t)>>8,e[0]=255&t,this.WriteStream(e)},WriteDWord:function(t){var e=new Uint8Array(4);e[3]=(4278190080&t)>>24,e[2]=(16711680&t)>>16,e[1]=(65280&t)>>8,e[0]=255&t,this.WriteStream(e)},WriteWord_Big:function(t){var e=new Uint8Array(2);e[1]=255&t,e[0]=(65280&t)>>8,this.WriteStream(e)},WriteDWord_Big:function(t){var e=new Uint8Array(4);e[3]=255&t,e[2]=(65280&t)>>8,e[1]=(16711680&t)>>16,e[0]=(4278190080&t)>>24,this.WriteStream(e)},WriteString:function(t){var e=this._AsciiToUint8Array(t);if(this.Stream.length<=this.Size+e.length){var a=new Uint8Array(this.Stream);this.Stream=new Uint8Array(this.Size+e.length+this.MemorySize),this.Stream.set(a.subarray(0,a.length))}this.Stream.set(e,this.Size),this.Size=this.Size+e.length},WriteStream:function(t){if(this.Stream.length<=this.Size+t.length){var e=new Uint8Array(this.Stream);this.Stream=new Uint8Array(this.Size+t.length+this.MemorySize),this.Stream.set(e.subarray(0,e.length))}this.Stream.set(t,this.Size),this.Size=this.Size+t.length},getFileSize:function(){return this.Size},SaveToFile:function(t,e){if(window.navigator.msSaveBlob)window.navigator.msSaveBlob(new Blob([this.Stream.subarray(0,this.Size)],{type:e}),t);else{var a=document.createElement("a");a.href=URL.createObjectURL(new Blob([this.Stream.subarray(0,this.Size)],{type:e})),a.download=t,document.body.appendChild(a),a.click(),document.body.removeChild(a)}}},TWaveFormat.prototype={getData:function(){if(1!=this.Analyst.WaveFomat.wFormatTag&&(3!=this.Analyst.WaveFomat.wFormatTag||32!=this.Analyst.WaveFomat.wBitsPerSample))throw"It is an unsupported format.";var t,e=this.Analyst.WaveFomat.nSamplesPerSec*(1*this.Analyst.WaveFomat.wBitsPerSample)*this.Analyst.time/1e3/this.Analyst.WaveFomat.wBitsPerSample,a=0,r=0,n={};switch(n.L=new Int32Array(e),n.R=new Int32Array(e),this.Analyst.WaveFomat.wBitsPerSample){case 8:if(1==this.Analyst.WaveFomat.nChannels)for(var s=0;s<this.Analyst.raw.length;s++)n.L[a++]=WAV_SetInt8(this.Analyst.raw[s]);else for(var s=0;s<this.Analyst.raw.length;s++)s%2==0?n.L[a++]=WAV_SetInt8(this.Analyst.raw[s]):n.R[r++]=WAV_SetInt8(this.Analyst.raw[s]);break;case 16:if(1==this.Analyst.WaveFomat.nChannels)for(var s=0;s<this.Analyst.raw.length/2;s++)t=2*s,n.L[a++]=WAV_SetInt16(this.Analyst.raw[t+1]<<8|this.Analyst.raw[t]);else for(var s=0;s<this.Analyst.raw.length/2;s++)t=2*s,s%2==0?n.L[a++]=WAV_SetInt16(this.Analyst.raw[t+1]<<8|this.Analyst.raw[t]):n.R[r++]=WAV_SetInt16(this.Analyst.raw[t+1]<<8|this.Analyst.raw[t]);break;case 24:if(1==this.Analyst.WaveFomat.nChannels)for(var s=0;s<this.Analyst.raw.length/3;s++)t=3*s,n.L[a++]=WAV_SetInt24(this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16);else for(var s=0;s<this.Analyst.raw.length/3;s++)t=3*s,s%2==0?n.L[a++]=WAV_SetInt24(this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16):n.R[r++]=WAV_SetInt24(this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16);break;case 32:if(1==this.Analyst.WaveFomat.wFormatTag)if(1==this.Analyst.WaveFomat.nChannels)for(var s=0;s<this.Analyst.raw.length/4;s++)t=4*s,n.L[a++]=WAV_SetInt32(this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16|this.Analyst.raw[t+3]<<24);else for(var s=0;s<this.Analyst.raw.length/4;s++)t=4*s,s%2==0?n.L[a++]=WAV_SetInt32(this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16|this.Analyst.raw[t+3]<<24):n.R[r++]=WAV_SetInt32(this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16|this.Analyst.raw[t+3]<<24);else{var i,l=new DataView(new ArrayBuffer(4));if(1==this.Analyst.WaveFomat.nChannels)for(var s=0;s<this.Analyst.raw.length/4;s++)t=4*s,l.setUint32(0,this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16|this.Analyst.raw[t+3]<<24,!1),i=l.getFloat32(0),i=i>=0?2147483647*i:2147483648*i,n.L[a++]=WAV_SetInt32(i);else for(var s=0;s<this.Analyst.raw.length/4;s++)t=4*s,s%2==0?(l.setUint32(0,this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16|this.Analyst.raw[t+3]<<24,!1),i=l.getFloat32(0),i=i>=0?2147483647*i:2147483648*i,n.L[a++]=WAV_SetInt32(i)):(l.setUint32(0,this.Analyst.raw[t]|this.Analyst.raw[t+1]<<8|this.Analyst.raw[t+2]<<16|this.Analyst.raw[t+3]<<24,!1),i=l.getFloat32(0),i=i>=0?2147483647*i:2147483648*i,n.R[r++]=WAV_SetInt32(i))}break;default:throw"It is an unsupported format."}return n},WriteStream:function(t,e,a){var r={};r.wFormatTag=1,r.wBitsPerSample=t,r.nSamplesPerSec=a,0==e.R.length?r.nChannels=1:r.nChannels=2,r.nBlockAlign=r.wBitsPerSample*r.nChannels/8,r.nAvgBytesPerSec=r.nSamplesPerSec*r.nBlockAlign;var n=new TFileStream;n.WriteString("RIFF"),n.WriteDWord((e.L.length+e.R.length)*(t/8)+36),n.WriteString("WAVE"),n.WriteString("fmt "),n.WriteDWord(16),n.WriteWord(r.wFormatTag),n.WriteWord(r.nChannels),n.WriteDWord(r.nSamplesPerSec),n.WriteDWord(r.nAvgBytesPerSec),n.WriteWord(r.nBlockAlign),n.WriteWord(r.wBitsPerSample),n.WriteString("data"),n.WriteDWord((e.L.length+e.R.length)*(t/8));for(var s,i=this.stepSize,l=this.instance.exports.memory.buffer,h=Math.floor(e.L.length/i),o=e.L.length%i,A=this.instance.exports.getAddress_L(),y=this.instance.exports.getAddress_R(),f=this.instance.exports.getAddress_Dst(),S=0;h>S;S++){var m=new Int32Array(l,A,i);if(m.set(e.L.subarray(S*i,S*i+i)),2==r.nChannels){var w=new Int32Array(l,y,i);w.set(e.R.subarray(S*i,S*i+i))}s=new Uint8Array(l,f,i*(t/8)*r.nChannels),this.instance.exports.run(i,t,r.nChannels),n.WriteStream(s)}if(0!=o){var m=new Int32Array(l,A,o);if(m.set(e.L.subarray(h*i,h*i+o)),2==r.nChannels){var w=new Int32Array(l,y,o);w.set(e.R.subarray(h*i,h*i+o))}s=new Uint8Array(l,f,o*(t/8)*r.nChannels),this.instance.exports.run(o,t,r.nChannels),n.WriteStream(s)}return n},SaveToStream:function(t,e,a,r){var n=this.getData();if(e?0==n.R.length&&(n.R=n.L.slice(0)):n.R=[],a!=this.Analyst.WaveFomat.nSamplesPerSec){for(var s=this.Analyst.WaveFomat.nSamplesPerSec/a,i=a*(1*t)*this.Analyst.time/1e3/t,l=new Int32Array(Math.floor(i)),h=0,o=0;o<l.length;o++)h+=s,l[o]=n.L[Math.floor(h-1)];if(n.L=l,0!=n.R.length){var A=new Int32Array(l.length);h=0;for(var o=0;o<l.length;o++)h+=s,A[o]=n.R[Math.floor(h-1)];n.R=A}}if(8==t){if(8==this.Analyst.WaveFomat.wBitsPerSample);else if(16==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>8;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>8,n.R[o]=n.R[o]>>8;else if(24==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>16;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>16,n.R[o]=n.R[o]>>16;else if(32==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>24;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>24,n.R[o]=n.R[o]>>24}else if(16==t){if(8==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<8;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<8,n.R[o]=n.R[o]<<8;else if(16==this.Analyst.WaveFomat.wBitsPerSample);else if(24==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>8;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>8,n.R[o]=n.R[o]>>8;else if(32==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>16;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>16,n.R[o]=n.R[o]>>16}else if(24==t){if(8==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<16;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<16,n.R[o]=n.R[o]<<16;else if(16==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<8;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<8,n.R[o]=n.R[o]<<8;else if(24==this.Analyst.WaveFomat.wBitsPerSample);else if(32==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>8;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]>>8,n.R[o]=n.R[o]>>8}else if(32==t)if(8==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<24;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<24,n.R[o]=n.R[o]<<24;else if(16==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<16;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<16,n.R[o]=n.R[o]<<16;else if(24==this.Analyst.WaveFomat.wBitsPerSample)if(0==n.R.length)for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<8;else for(var o=0;o<n.L.length;o++)n.L[o]=n.L[o]<<8,n.R[o]=n.R[o]<<8;else 32==this.Analyst.WaveFomat.wBitsPerSample;var y=this.WriteStream(t,n,a);return r?y.Stream.subarray(0,y.getFileSize()):y},SaveToFile:function(t,e,a,r){var n=this.SaveToStream(e,a,r,!1);n.SaveToFile(t,"audio/wav")},drawCanvas:function(t,e){function a(t,e){if(0==t)return 0;var a;return t>=0?(a=32767/e,t/a):(a=32768/e,Math.abs(t)/a)}function r(t,e,r,n){var s=t.height,i=Math.floor(s/2),l=t.getContext("2d"),h=Math.floor(e.length/t.width),o=[],A=[];if(0!=h)for(var y=0;y<e.length/h-1;y++){var f=y*h,S=e.slice(f,f+h),m=S.reduce(function(t,e){return t>e?t:e}),w=S.reduce(function(t,e){return t>e?e:t});o.push(a(m,i)),A.push(a(w,i+1))}else console.log("Drawing was not possible because the amount of data is small.");l.fillStyle="silver",l.clearRect(0,0,t.width,t.height),l.beginPath(),l.moveTo(0,i),l.lineTo(t.width,i),l.stroke(),l.beginPath(),l.moveTo(t.width/2,0),l.lineTo(t.width/2,t.height),l.stroke();for(var y=0;y<o.length;y++)o[y]+A[y]!=0&&l.fillRect(y,i-o[y],1,o[y]+A[y]);l.fillStyle="rgb(0, 0, 0)",l.font='18px "Times New Roman"',l.fillText(r,5,20),l.fillText("0s",3,s-10);var v=Math.round(n.Analyst.time/1e3/2*1e3)/1e3+"s",W=3.5*v.length;l.fillText(v,t.width/2-W,s-10);var g=Math.round(n.Analyst.time)/1e3+"s",L=9*g.length;l.fillText(g,t.width-L,s-10)}var n=this;if(16!=this.Analyst.WaveFomat.wBitsPerSample){var s;s=1!=this.Analyst.WaveFomat.nChannels;var i=this.SaveToStream(16,s,this.Analyst.WaveFomat.nSamplesPerSec,!0);n=new TWaveFormat(this.instance,i)}var l=n.getData();1==n.Analyst.WaveFomat.nChannels?r(t,l.L,"[ Mono ]",n):(r(t,l.L,"[ L ]",n),r(e,l.R,"[ R ]",n))}};